import * as React from 'react';
import InputDefaultProps from '../inputDefaultProps';

declare var jQuery: any;

export interface ICombogridColModel {
    title?:string;
    width?:string;
    align?:string;
    hide?:boolean;
    columnName?: string;
    label?:string;
}

export interface ICombogridProps extends InputDefaultProps {
    url? (): string,
    colModel? (): [ICombogridColModel],
    delay?: number,
    replaceNull?: boolean,
    showOn?: boolean,
    width?: number,
    position?: any,
    searchOptions? (): any,
    searchField? (): any,
    select? (event: any, ui: any) : void,
    template? (selectedItem: any): string
}

export interface ICombogridState {
}

export class Combogrid extends React.Component<ICombogridProps, ICombogridState> {
    
    elInput: HTMLInputElement
    apiCombogrid: any;

    constructor(props: ICombogridProps) {
        super(props);
    }
    
    componentDidMount() {
        let props = this.props;
        
        if (!this.props.select) {
            props = {...this.props, showOn: true, select: (event: Event, ui: any) => {
                this.elInput.value = this.props.template(ui.item);
                return false;
            }}
        }

        jQuery(this.elInput).combogrid(props);
        this.apiCombogrid = jQuery(this.elInput).data('combogrid');
    }

    render() {
        let inputClassName = (this.props.obrigatorio ? "obrigatorio" : "") + " combogrid_arrow_button";
        let styles = {
            width: this.props.tamanho || "auto"
        }
        
        return (
            <input 
                type="text"
                ref={ (el) => this.elInput = el }
                name={this.props.inputName} 
                className={inputClassName} 
                style={styles} 
                disabled={!this.props.habilitado} />
        );
    }
}