import * as React from 'react';
import styles from "./styles"

export interface IModalProps {
    visivel: boolean,
    titulo?: string,
    centralizado?: boolean,
    barraInferior?: any,
    children?: any
}

export interface IModalState {

}

export class Modal extends React.Component<IModalProps, IModalState> {
    
    elModal: HTMLDivElement;

    constructor(props: IModalProps) {
        super(props);
    }

    componentDidMount() {
        if (this.props.visivel && this.props.centralizado) {
            this.centralizaModal();
        }
    }

    componentDidUpdate(prevProps: IModalProps) {
        if (prevProps.visivel != this.props.visivel && this.props.visivel && this.props.centralizado) {
            this.centralizaModal();
        }
    }

    centralizaModal() {
        let centerX = (document.body.clientWidth - this.elModal.offsetWidth) / 2;
        this.elModal.style.left = centerX + "px";
    }

    render() {
        styles.wrap = {...styles.wrap, display: this.props.visivel ? "block" : "none"};
        
        return (
            <div style={styles.wrap}>
                <div style={styles.overlay}/>
                <div ref={(el) => this.elModal = el} style={styles.modal}>
                    <div style={styles.barraDeTitulo}>
                        {this.props.titulo}
                    </div>
                    <div style={styles.conteudo}>
                        {this.props.children}
                    </div>
                    <div style={styles.barraInferior}>
                        {this.props.barraInferior}
                    </div>
                </div>
            </div>
        );
    }
}